// types/next-auth.d.ts
import NextAuth, { DefaultSession } from "next-auth";
import { ProjectInterface } from "./project";

export declare module "next-auth" {
  /**
   * Returned by `useSession`, `getSession` and received as
   * a prop on the `SessionProvider` React Context
   */
  interface Session {
    refreshTokenExpires?: number;
    accessTokenExpires?: string;
    refreshToken?: string;
    token?: string;
    error?: string;
    role?: string;
    user: User;
    assignmentStatus: AssignmentStatus[];
    batchStatus?: string[];
    locationStatus?: string[];
    projects?: ProjectInterface[];
    currentProjectId?: string;
  }

  interface User {
    id: number;
    first_name: string;
    last_name: string;
    full_name: string;
    email: string;
    is_system_admin: number;
    roles: string[];
    permissions: string[];
    assignmentStatus: AssignmentStatus[];
    batchStatuses: string[];
    locationStatuses: string[];
    projects?: string[];
    currentProjectId?: string;
    currentProject: ProjectInterface;
    token: string;
  }

  interface AssignmentStatus {
    id: number;
    name: string;
  }

  interface Role {
    id: number;
    name: string;
  }
}



// declare module "next-auth/jwt" {
//   /** Returned by the `jwt` callback and `getToken`, when using JWT sessions */
//   interface JWT {
//     refreshTokenExpires?: number;
//     accessTokenExpires?: number;
//     refreshToken?: string;
//     token: string;
//     access_token: string;
//     exp?: number;
//     iat?: number;
//     jti?: string;
//     user?: any;
//   }
// }
